From 1ddaa258e830264a5e75763f2d06d1c9d262660c Mon Sep 17 00:00:00 2001
From: Nikita Voronchev <nikita.voronchev@ru.axxonsoft.com>
Date: Tue, 13 Apr 2021 16:03:26 +0300
Subject: [PATCH] [WinForms] DataGridView: Update editing control position on
 scroll (#20675)

This pull request fixes the following issue. Let's go to edit mode of some cell from a `DataGridView` control. Then appeared text box will keep its locations if one scroll the grid.
---
 .../System.Windows.Forms/DataGridView.cs      | 43 ++++++++++++-------
 1 file changed, 27 insertions(+), 16 deletions(-)

diff --git a/mcs/class/System.Windows.Forms/System.Windows.Forms/DataGridView.cs b/mcs/class/System.Windows.Forms/System.Windows.Forms/DataGridView.cs
index c9d782df29592..6c29a77c62b11 100644
--- a/mcs/class/System.Windows.Forms/System.Windows.Forms/DataGridView.cs
+++ b/mcs/class/System.Windows.Forms/System.Windows.Forms/DataGridView.cs
@@ -2341,10 +2341,10 @@ public void AutoResizeRows (DataGridViewAutoSizeRowsMode autoSizeRowsMode)
 				}
 				
 				// Call some functions that allows the editing control to get setup
-				DataGridViewCellStyle style = cell.RowIndex == -1 ? DefaultCellStyle : cell.InheritedStyle;
+				var style = GetCellStyle (cell);
 				cell.InitializeEditingControl (cell.RowIndex, cell.FormattedValue, style);
 				OnEditingControlShowing (new DataGridViewEditingControlShowingEventArgs (EditingControlInternal, style));
-				cell.PositionEditingControl (true, true, this.GetCellDisplayRectangle (cell.ColumnIndex, cell.RowIndex, false), bounds, style, false, false, (columns [cell.ColumnIndex].DisplayIndex == 0), (cell.RowIndex == 0));
+				PositionCellEditingControl (cell, style);
 
 				// Show the editing control
 				if (EditingControlInternal != null)
@@ -5877,21 +5877,16 @@ internal void OnHScrollBarScroll (object sender, ScrollEventArgs e)
 
 			for (int index = 0; index < Columns.Count; index++) {
 				DataGridViewColumn col = Columns[index];
-
 				if (col.Index >= lastRightVisibleColumntIndex) {
 					first_col_index = lastRightVisibleColumntIndex;
-					Invalidate ();
-					OnScroll (e);
+					OnAnyScrollBarScroll (e);
 				} else if (e.NewValue < left + col.Width) {
 					if (first_col_index != index) {
 						first_col_index = index;
-						Invalidate ();
-						OnScroll (e);
+						OnAnyScrollBarScroll (e);
 					}
-
 					return;
 				}
-
 				left += col.Width;
 			}
 		}
@@ -5912,24 +5907,40 @@ internal void OnVScrollBarScroll (object sender, ScrollEventArgs e)
 
 				if (row.Index >= lastTopVisibleRowIndex) {
 					first_row_index = lastTopVisibleRowIndex;
-					Invalidate ();
-					OnScroll (e);
+					OnAnyScrollBarScroll (e);
 				} else if (e.NewValue < top + row.Height) {
 					if (first_row_index != index) {
 						first_row_index = index;
-						Invalidate ();
-						OnScroll (e);
+						OnAnyScrollBarScroll (e);
 					}
-					
 					return;
 				}
-				
 				top += row.Height;
 			}
-			
+		
 			first_row_index = lastTopVisibleRowIndex;
+			OnAnyScrollBarScroll (e);
+		}
+
+		private void OnAnyScrollBarScroll(ScrollEventArgs e)
+		{
 			Invalidate ();
 			OnScroll (e);
+			if (currentCell != null && currentCell.IsInEditMode) {
+				var style = GetCellStyle (currentCell);
+				PositionCellEditingControl (currentCell, style);
+			}
+		}
+
+		private DataGridViewCellStyle GetCellStyle (DataGridViewCell cell)
+		{
+			return cell.RowIndex == -1 ? DefaultCellStyle : cell.InheritedStyle;
+		}
+
+		private void PositionCellEditingControl (DataGridViewCell cell, DataGridViewCellStyle style)
+		{
+			cell.PositionEditingControl (
+				true, true, this.GetCellDisplayRectangle (cell.ColumnIndex, cell.RowIndex, false), bounds, style, false, false, (columns [cell.ColumnIndex].DisplayIndex == 0), (cell.RowIndex == 0));
 		}
 
 		internal void RaiseCellStyleChanged (DataGridViewCellEventArgs e) {
